<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Documento StructType
 * @subpackage Structs
 */
class Documento extends AbstractStructBase
{
    /**
     * The RutEmisor
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $RutEmisor;
    /**
     * The Tipo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Tipo;
    /**
     * The Folio
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Folio;
    /**
     * The FechaEmision
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FechaEmision;
    /**
     * The FechaCarga
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FechaCarga;
    /**
     * Constructor method for Documento
     * @uses Documento::setRutEmisor()
     * @uses Documento::setTipo()
     * @uses Documento::setFolio()
     * @uses Documento::setFechaEmision()
     * @uses Documento::setFechaCarga()
     * @param string $rutEmisor
     * @param string $tipo
     * @param string $folio
     * @param string $fechaEmision
     * @param string $fechaCarga
     */
    public function __construct($rutEmisor = null, $tipo = null, $folio = null, $fechaEmision = null, $fechaCarga = null)
    {
        $this
            ->setRutEmisor($rutEmisor)
            ->setTipo($tipo)
            ->setFolio($folio)
            ->setFechaEmision($fechaEmision)
            ->setFechaCarga($fechaCarga);
    }
    /**
     * Get RutEmisor value
     * @return string|null
     */
    public function getRutEmisor()
    {
        return $this->RutEmisor;
    }
    /**
     * Set RutEmisor value
     * @param string $rutEmisor
     * @return \StructType\Documento
     */
    public function setRutEmisor($rutEmisor = null)
    {
        // validation for constraint: string
        if (!is_null($rutEmisor) && !is_string($rutEmisor)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rutEmisor, true), gettype($rutEmisor)), __LINE__);
        }
        $this->RutEmisor = $rutEmisor;
        return $this;
    }
    /**
     * Get Tipo value
     * @return string|null
     */
    public function getTipo()
    {
        return $this->Tipo;
    }
    /**
     * Set Tipo value
     * @param string $tipo
     * @return \StructType\Documento
     */
    public function setTipo($tipo = null)
    {
        // validation for constraint: string
        if (!is_null($tipo) && !is_string($tipo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($tipo, true), gettype($tipo)), __LINE__);
        }
        $this->Tipo = $tipo;
        return $this;
    }
    /**
     * Get Folio value
     * @return string|null
     */
    public function getFolio()
    {
        return $this->Folio;
    }
    /**
     * Set Folio value
     * @param string $folio
     * @return \StructType\Documento
     */
    public function setFolio($folio = null)
    {
        // validation for constraint: string
        if (!is_null($folio) && !is_string($folio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($folio, true), gettype($folio)), __LINE__);
        }
        $this->Folio = $folio;
        return $this;
    }
    /**
     * Get FechaEmision value
     * @return string|null
     */
    public function getFechaEmision()
    {
        return $this->FechaEmision;
    }
    /**
     * Set FechaEmision value
     * @param string $fechaEmision
     * @return \StructType\Documento
     */
    public function setFechaEmision($fechaEmision = null)
    {
        // validation for constraint: string
        if (!is_null($fechaEmision) && !is_string($fechaEmision)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaEmision, true), gettype($fechaEmision)), __LINE__);
        }
        $this->FechaEmision = $fechaEmision;
        return $this;
    }
    /**
     * Get FechaCarga value
     * @return string|null
     */
    public function getFechaCarga()
    {
        return $this->FechaCarga;
    }
    /**
     * Set FechaCarga value
     * @param string $fechaCarga
     * @return \StructType\Documento
     */
    public function setFechaCarga($fechaCarga = null)
    {
        // validation for constraint: string
        if (!is_null($fechaCarga) && !is_string($fechaCarga)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fechaCarga, true), gettype($fechaCarga)), __LINE__);
        }
        $this->FechaCarga = $fechaCarga;
        return $this;
    }
}
