<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ResultadoListadoDTE StructType
 * @subpackage Structs
 */
class ResultadoListadoDTE extends AbstractStructBase
{
    /**
     * The cantDTE
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $cantDTE;
    /**
     * The Documentos
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfDocumento
     */
    public $Documentos;
    /**
     * The Codigo
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Codigo;
    /**
     * The Mensajes
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Mensajes;
    /**
     * Constructor method for ResultadoListadoDTE
     * @uses ResultadoListadoDTE::setCantDTE()
     * @uses ResultadoListadoDTE::setDocumentos()
     * @uses ResultadoListadoDTE::setCodigo()
     * @uses ResultadoListadoDTE::setMensajes()
     * @param int $cantDTE
     * @param \ArrayType\ArrayOfDocumento $documentos
     * @param string $codigo
     * @param string $mensajes
     */
    public function __construct($cantDTE = null, \ArrayType\ArrayOfDocumento $documentos = null, $codigo = null, $mensajes = null)
    {
        $this
            ->setCantDTE($cantDTE)
            ->setDocumentos($documentos)
            ->setCodigo($codigo)
            ->setMensajes($mensajes);
    }
    /**
     * Get cantDTE value
     * @return int
     */
    public function getCantDTE()
    {
        return $this->cantDTE;
    }
    /**
     * Set cantDTE value
     * @param int $cantDTE
     * @return \StructType\ResultadoListadoDTE
     */
    public function setCantDTE($cantDTE = null)
    {
        // validation for constraint: int
        if (!is_null($cantDTE) && !(is_int($cantDTE) || ctype_digit($cantDTE))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($cantDTE, true), gettype($cantDTE)), __LINE__);
        }
        $this->cantDTE = $cantDTE;
        return $this;
    }
    /**
     * Get Documentos value
     * @return \ArrayType\ArrayOfDocumento|null
     */
    public function getDocumentos()
    {
        return $this->Documentos;
    }
    /**
     * Set Documentos value
     * @param \ArrayType\ArrayOfDocumento $documentos
     * @return \StructType\ResultadoListadoDTE
     */
    public function setDocumentos(\ArrayType\ArrayOfDocumento $documentos = null)
    {
        $this->Documentos = $documentos;
        return $this;
    }
    /**
     * Get Codigo value
     * @return string|null
     */
    public function getCodigo()
    {
        return $this->Codigo;
    }
    /**
     * Set Codigo value
     * @param string $codigo
     * @return \StructType\ResultadoListadoDTE
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: string
        if (!is_null($codigo) && !is_string($codigo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->Codigo = $codigo;
        return $this;
    }
    /**
     * Get Mensajes value
     * @return string|null
     */
    public function getMensajes()
    {
        return $this->Mensajes;
    }
    /**
     * Set Mensajes value
     * @param string $mensajes
     * @return \StructType\ResultadoListadoDTE
     */
    public function setMensajes($mensajes = null)
    {
        // validation for constraint: string
        if (!is_null($mensajes) && !is_string($mensajes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensajes, true), gettype($mensajes)), __LINE__);
        }
        $this->Mensajes = $mensajes;
        return $this;
    }
}
